Skip to main content

Angular Konva Undo-Redo Tutorial

Undo and redo work best when canvas state is stored in plain data objects instead of reading values back from the canvas on every render.

This example stores rectangle positions in a small history stack and restores previous snapshots when you click Undo or Redo.

Instructions: Drag the rectangle to create history entries, then click Undo and Redo to move through the saved states.

For more details, see the Rect API Reference.

Undo-Redo Example

import { Component } from '@angular/core';
import { StageConfig } from 'konva/lib/Stage';
import { RectConfig } from 'konva/lib/shapes/Rect';

import {
  CoreShapeComponent,
  StageComponent,
} from 'ng2-konva';

@Component({
  selector: 'app-root',
  standalone: true,
  template: `
    <div>
      <button (click)="undo()" [disabled]="!canUndo()">Undo</button>
      <button (click)="redo()" [disabled]="!canRedo()">Redo</button>
      <ko-stage [config]="configStage">
        <ko-layer>
          <ko-rect 
            [config]="configRect"
            (dragend)="handleDragEnd($event.event)"
          ></ko-rect>
        </ko-layer>
      </ko-stage>
    </div>
  `,
  imports: [StageComponent, CoreShapeComponent],
})
export default class App {
  private history: RectConfig[] = [];
  private currentIndex: number = -1;

  public configStage: StageConfig = {
    width: window.innerWidth,
    height: window.innerHeight,
  };
  public configRect: RectConfig = {
    x: 100,
    y: 100,
    width: 100,
    height: 100,
    fill: 'red',
    draggable: true
  };

  constructor() {
    this.saveState();
  }

  private saveState(): void {
    // Remove any states after current index
    this.history = this.history.slice(0, this.currentIndex + 1);
    
    // Add current state
    this.history.push({ ...this.configRect });
    this.currentIndex++;
  }

  public handleDragEnd(event: any): void {
    this.configRect = {
      ...this.configRect,
      x: event.target.x(),
      y: event.target.y()
    };
    this.saveState();
  }

  public undo(): void {
    if (this.canUndo()) {
      this.currentIndex--;
      this.configRect = { ...this.history[this.currentIndex] };
    }
  }

  public redo(): void {
    if (this.canRedo()) {
      this.currentIndex++;
      this.configRect = { ...this.history[this.currentIndex] };
    }
  }

  public canUndo(): boolean {
    return this.currentIndex > 0;
  }

  public canRedo(): boolean {
    return this.currentIndex < this.history.length - 1;
  }
}

Skip to main content

How to implement undo/redo on canvas with Vue?

To implement undo/redo functionality with Vue, you don't need to use Konva's serialization and deserialization methods.

You just need to save a history of all the state changes within your app. There are many ways to do this. It may be simpler to do that if you use immutable structures.

Instructions: Try to move the square by dragging it. Then use the "undo" and "redo" buttons to revert or replay your actions.

<template>
<v-stage :config="stageSize">
<v-layer>
<v-text
:config="{
text: 'undo',
x: 10,
y: 10
}"
@click="handleUndo"
/>
<v-text
:config="{
text: 'redo',
x: 50,
y: 10
}"
@click="handleRedo"
/>
<v-rect
:config="{
x: position.x,
y: position.y,
width: 50,
height: 50,
fill: 'black',
draggable: true
}"
@dragend="handleDragEnd"
/>
</v-layer>
</v-stage>
</template>

<script setup>
import { ref, reactive } from 'vue';

const stageSize = {
width: window.innerWidth,
height: window.innerHeight
};

const position = reactive({ x: 20, y: 20 });
// We use refs to keep history to avoid unnecessary re-renders
const history = ref([{ x: 20, y: 20 }]);
const historyStep = ref(0);

const handleUndo = () => {
if (historyStep.value === 0) {
return;
}
historyStep.value -= 1;
const previous = history.value[historyStep.value];
position.x = previous.x;
position.y = previous.y;
};

const handleRedo = () => {
if (historyStep.value === history.value.length - 1) {
return;
}
historyStep.value += 1;
const next = history.value[historyStep.value];
position.x = next.x;
position.y = next.y;
};

const handleDragEnd = (e) => {
// Remove all states after current step
history.value = history.value.slice(0, historyStep.value + 1);
const pos = {
x: e.target.x(),
y: e.target.y()
};
// Push the new state
history.value = history.value.concat([pos]);
historyStep.value += 1;
position.x = pos.x;
position.y = pos.y;
};
</script>

The demo shows how to:

  1. Keep track of position history using Vue's reactivity system
  2. Implement undo/redo functionality by navigating through the history
  3. Update the history when dragging ends
  4. Use reactive for the current position and ref for the history to maintain reactivity

Note that we're using Vue's reactivity system to manage the state, but we're careful to avoid unnecessary re-renders by keeping the history in a ref.

Where a hand-built history stops

The history above records one value per step. A production editor has to record grouped operations, so that a multi-select drag undoes as a single step, plus transforms and images that finish loading after the action. That state machine usually grows larger than the drawing code, so plan the history around document operations rather than around raw node state.

Skip to main content

How to implement undo/redo on canvas with React?

To implement undo/redo functionality with React you don't need to use Konva's serialization and deserialization methods.

You just need to save a history of all the state changes within your app. There are many ways to do this. It may be simpler to do that if you use immutable structures.

Instructions: Try to move the square by dragging it. Then use the "undo" and "redo" buttons to revert or replay your actions.

import React, { Component } from 'react';
import { Stage, Layer, Rect, Text } from 'react-konva';


const App = () => {
  const [position, setPosition] = React.useState({ x: 20, y: 20 });
  // We use refs to keep history to avoid unnecessary re-renders
  const history = React.useRef([{ x: 20, y: 20 }]);
  const historyStep = React.useRef(0);

  const handleUndo = () => {
    if (historyStep.current === 0) {
      return;
    }
    historyStep.current -= 1;
    const previous = history.current[historyStep.current];
    setPosition(previous);
  };

  const handleRedo = () => {
    if (historyStep.current === history.current.length - 1) {
      return;
    }
    historyStep.current += 1;
    const next = history.current[historyStep.current];
    setPosition(next);
  };

  const handleDragEnd = (e) => {
    // Remove all states after current step
    history.current = history.current.slice(0, historyStep.current + 1);
    const pos = {
      x: e.target.x(),
      y: e.target.y(),
    };
    // Push the new state
    history.current = history.current.concat([pos]);
    historyStep.current += 1;
    setPosition(pos);
  };

  return (
    <Stage width={window.innerWidth} height={window.innerHeight}>
      <Layer>
        <Text text="undo" onClick={handleUndo} />
        <Text text="redo" x={40} onClick={handleRedo} />
        <Rect
          x={position.x}
          y={position.y}
          width={50}
          height={50}
          fill="black"
          draggable
          onDragEnd={handleDragEnd}
        />
      </Layer>
    </Stage>
  );
};

export default App;